Index: squid/src/client_side.c
diff -u squid/src/client_side.c:1.24 squid/src/client_side.c:1.2.2.25
--- squid/src/client_side.c:1.24	Sun Mar  4 05:45:04 2001
+++ squid/src/client_side.c	Sun Mar 18 14:51:21 2001
@@ -2046,60 +1718,68 @@
     err->request = requestLink(r);
     err->src_addr = http->conn->peer.sin_addr;
     if (http->entry) {
-	storeUnregister(http->sc, http->entry, http);
-	http->sc = NULL;
+	storeClientUnregister(http->entry, http);
 	storeUnlockObject(http->entry);
     }
-    http->entry = clientCreateStoreEntry(http, r->method, null_request_flags);
+    http->entry = clientCreateStoreEntry(http, r->method, null_request_flags,
+      REPLY_OBJ_INTERNAL);
     errorAppendEntry(http->entry, err);
 }
 
-/* 
- * Return true if we should force a cache miss on this range request.
- * entry must be non-NULL.
+
+/*
+ * clientLookupDone - handle the result of the first lookup
+ *
+ * If the result of the first lookup is a MISS and the method is METHOD_HEAD,
+ * we can generate a HEAD reply from a cached GET object, so initiate a
+ * second lookup. Otherwise, call clientProcessRequest2() to get the
+ * cache hit/miss information, and punt to clientProcessRequestDone().
  */
-static int
-clientCheckRangeForceMiss(StoreEntry * entry, HttpHdrRange * range)
+static void
+clientLookupDone(void *data, StoreEntry *e)
 {
-    /*
-     * If the range_offset_limit is NOT in effect, there
-     * is no reason to force a miss.
-     */
-    if (0 == httpHdrRangeOffsetLimit(range))
-	return 0;
-    /*
-     * Here, we know it's possibly a hit.  If we already have the
-     * whole object cached, we won't force a miss.
-     */
-    if (STORE_OK == entry->store_status)
-	return 0;		/* we have the whole object */
-    /*
-     * Now we have a hit on a PENDING object.  We need to see
-     * if the part we want is already cached.  If so, we don't
-     * force a miss.
-     */
-    assert(NULL != entry->mem_obj);
-    if (httpHdrRangeFirstOffset(range) <= entry->mem_obj->inmem_hi)
-	return 0;
-    /*
-     * Even though we have a PENDING copy of the object, we
-     * don't want to wait to reach the first range offset,
-     * so we force a miss for a new range request to the
-     * origin.
-     */
-    return 1;
+    clientHttpRequest *http = data;
+
+    if (http->request->method == METHOD_HEAD && e == NULL) {
+        /*
+         * Start off the GET lookup, and change the request to be a
+         * HEAD afterwards
+         */
+        http->request->method = METHOD_GET;
+        storeDoubleCheckRequest(http->request, http->uri, METHOD_GET);
+        storeLookup(http->request, clientLookupHeadDone, http);
+        http->request->method = METHOD_HEAD;
+    } else {
+        /* We have to continue with our result, NULL or not */
+        http->log_type = clientProcessRequest2(http, e);
+        clientProcessRequestDone(http);
+    }
+    /* NOTREACHED */
 }
 
+/*
+ * clientLookupHeadDone - handle the HEAD -> GET request
+ *
+ * Similar to clientLookupDone(), we simply call clientProcessRequest2
+ */
+static void
+clientLookupHeadDone(void *data, StoreEntry *e)
+{
+    clientHttpRequest *http = data;
+
+    http->log_type = clientProcessRequest2(http, e);
+    clientProcessRequestDone(http);
+}
+
+/*
+ * decide whether we've got a cache HIT or MISS, and then punt across
+ * to clientProcessRequestDone()
+ */
 static log_type
-clientProcessRequest2(clientHttpRequest * http)
+clientProcessRequest2(clientHttpRequest * http, StoreEntry *e)
 {
     request_t *r = http->request;
-    StoreEntry *e;
-    e = http->entry = storeGetPublic(http->uri, r->method);
-    if (r->method == METHOD_HEAD && e == NULL) {
-	/* We can generate a HEAD reply from a cached GET object */
-	e = http->entry = storeGetPublic(http->uri, METHOD_GET);
-    }
+
     /* Release negatively cached IP-cache entries on reload */
     if (r->flags.nocache)
 	ipcacheInvalidate(r->host);
@@ -2112,7 +1792,7 @@
 #endif
     if (NULL == e) {
 	/* this object isn't in the cache */
-	debug(33, 3) ("clientProcessRequest2: storeGet() MISS\n");
+	debug(33, 3) ("clientProcessRequest2: storeLookup() MISS\n");
 	return LOG_TCP_MISS;
     }
     if (Config.onoff.offline) {
@@ -2151,21 +1831,14 @@
 	http->entry = NULL;
 	ipcacheInvalidate(r->host);
 	return LOG_TCP_CLIENT_REFRESH_MISS;
-    }
-    if (NULL == r->range) {
-	(void) 0;
-    } else if (httpHdrRangeWillBeComplex(r->range)) {
+    } else if (r->flags.range) {
 	/*
 	 * Some clients break if we return "200 OK" for a Range
 	 * request.  We would have to return "200 OK" for a _complex_
 	 * Range request that is also a HIT. Thus, let's prevent HITs
 	 * on complex Range requests
 	 */
-	debug(33, 3) ("clientProcessRequest2: complex range MISS\n");
-	http->entry = NULL;
-	return LOG_TCP_MISS;
-    } else if (clientCheckRangeForceMiss(e, r->range)) {
-	debug(33, 3) ("clientProcessRequest2: forcing miss due to range_offset_limit\n");
+	debug(33, 3) ("clientProcessRequest2: range MISS\n");
 	http->entry = NULL;
 	return LOG_TCP_MISS;
     }
@@ -2190,11 +1863,12 @@
 	sslStart(fd, url, r, &http->out.size, &http->al.http.code);
 	return;
     } else if (r->method == METHOD_PURGE) {
-	clientPurgeRequest(http);
+	clientStartPurgeRequest(http);
 	return;
     } else if (r->method == METHOD_TRACE) {
 	if (r->max_forwards == 0) {
-	    http->entry = clientCreateStoreEntry(http, r->method, null_request_flags);
+	    http->entry = clientCreateStoreEntry(http, r->method,
+              null_request_flags, REPLY_OBJ_INTERNAL);
 	    storeReleaseRequest(http->entry);
 	    storeBuffer(http->entry);
 	    rep = httpReplyCreate();
@@ -2210,25 +1884,44 @@
 	/* yes, continue */
 	http->log_type = LOG_TCP_MISS;
     } else {
-	http->log_type = clientProcessRequest2(http);
+        /* We need to initiate a lookup, so defer completing the request */
+        debug(33, 3) ("clientProcessRequest: looking up %s\n", http->uri);
+        storeDoubleCheckRequest(r, http->uri, r->method);
+        storeLookup(r, clientLookupDone, http);
+        return;
     }
-    debug(33, 4) ("clientProcessRequest: %s for '%s'\n",
+    /* Continue processing */
+    clientProcessRequestDone(http);
+}
+
+
+/*
+ * clientProcessRequestDone - the completion of the request chain
+ *
+ * Either start getting data from a cached object, or punt across
+ * to clientProcessMiss().
+ */
+static void
+clientProcessRequestDone(clientHttpRequest *http)
+{
+    debug(33, 4) ("clientProcessRequestDone: %s for '%s'\n",
 	log_tags[http->log_type],
 	http->uri);
     http->out.offset = 0;
     if (NULL != http->entry) {
 	storeLockObject(http->entry);
 	storeCreateMemObject(http->entry, http->uri, http->log_uri);
-	http->entry->mem_obj->method = r->method;
-	http->sc = storeClientListAdd(http->entry, http);
+	http->entry->mem_obj->method = http->request->method;
+	storeClientRegister(http->entry, http);
 #if DELAY_POOLS
-	delaySetStoreClient(http->sc, delayClient(r));
+	delaySetStoreClient(http->sc, delayClient(http->request));
 #endif
-	storeClientCopy(http->sc, http->entry,
+        http->bufofs = 0;
+	storeClientCopy(http->entry,
 	    http->out.offset,
 	    http->out.offset,
 	    CLIENT_SOCK_SZ,
-	    memAllocate(MEM_CLIENT_SOCK_BUF),
+	    http->buf,
 	    clientCacheHit,
 	    http);
     } else {
@@ -2258,8 +1951,7 @@
 	    debug(33, 0) ("\tlog_type = %s\n", log_tags[http->log_type]);
 	    storeEntryDump(http->entry, 1);
 	}
-	storeUnregister(http->sc, http->entry, http);
-	http->sc = NULL;
+	storeClientUnregister(http->entry, http);
 	storeUnlockObject(http->entry);
 	http->entry = NULL;
     }
@@ -2275,12 +1967,14 @@
 	err = errorCon(ERR_ACCESS_DENIED, HTTP_FORBIDDEN);
 	err->request = requestLink(r);
 	err->src_addr = http->conn->peer.sin_addr;
-	http->entry = clientCreateStoreEntry(http, r->method, null_request_flags);
+	http->entry = clientCreateStoreEntry(http, r->method,
+          null_request_flags, REPLY_OBJ_INTERNAL);
 	errorAppendEntry(http->entry, err);
 	return;
     }
     assert(http->out.offset == 0);
-    http->entry = clientCreateStoreEntry(http, r->method, r->flags);
+    http->entry = clientCreateStoreEntry(http, r->method, r->flags,
+      REPLY_OBJ_NETWORK);
     if (http->redirect.status) {
 	HttpReply *rep = httpReplyCreate();
 #if LOG_TCP_REDIRECTS
@@ -2302,6 +1996,7 @@
 parseHttpRequestAbort(ConnStateData * conn, const char *uri)
 {
     clientHttpRequest *http;
+    CBDATA_INIT_TYPE_FREECB(clientHttpRequest, httpMemFree);
     http = cbdataAlloc(clientHttpRequest);
     http->conn = conn;
     http->start = current_time;
@@ -2309,6 +2004,7 @@
     http->uri = xstrdup(uri);
     http->log_uri = xstrndup(uri, MAX_URL);
     http->range_iter.boundary = StringNull;
+    http->buf = memAllocate(MEM_CLIENT_SOCK_BUF);
     dlinkAdd(http, &http->active, &ClientActiveRequests);
     return http;
 }
@@ -2441,12 +2137,14 @@
     assert(prefix_sz <= conn->in.offset);
 
     /* Ok, all headers are received */
+    CBDATA_INIT_TYPE_FREECB(clientHttpRequest, httpMemFree);
     http = cbdataAlloc(clientHttpRequest);
     http->http_ver = http_ver;
     http->conn = conn;
     http->start = current_time;
     http->req_sz = prefix_sz;
     http->range_iter.boundary = StringNull;
+    http->buf = memAllocate(MEM_CLIENT_SOCK_BUF);
     *prefix_p = xmalloc(prefix_sz + 1);
     xmemcpy(*prefix_p, conn->in.buf, prefix_sz);
     *(*prefix_p + prefix_sz) = '\0';
@@ -2719,7 +2417,8 @@
 		debug(33, 1) ("clientReadRequest: FD %d Invalid Request\n", fd);
 		err = errorCon(ERR_INVALID_REQ, HTTP_BAD_REQUEST);
 		err->request_hdrs = xstrdup(conn->in.buf);
-		http->entry = clientCreateStoreEntry(http, method, null_request_flags);
+		http->entry = clientCreateStoreEntry(http, method,
+                  null_request_flags, REPLY_OBJ_INTERNAL);
 		errorAppendEntry(http->entry, err);
 		safe_free(prefix);
 		break;
@@ -2730,7 +2429,8 @@
 		err->src_addr = conn->peer.sin_addr;
 		err->url = xstrdup(http->uri);
 		http->al.http.code = err->http_status;
-		http->entry = clientCreateStoreEntry(http, method, null_request_flags);
+		http->entry = clientCreateStoreEntry(http, method,
+                  null_request_flags, REPLY_OBJ_INTERNAL);
 		errorAppendEntry(http->entry, err);
 		safe_free(prefix);
 		break;
@@ -2774,7 +2474,8 @@
 		err->request = requestLink(request);
 		request->flags.proxy_keepalive = 0;
 		http->al.http.code = err->http_status;
-		http->entry = clientCreateStoreEntry(http, request->method, null_request_flags);
+		http->entry = clientCreateStoreEntry(http, request->method,
+                  null_request_flags, REPLY_OBJ_INTERNAL);
 		errorAppendEntry(http->entry, err);
 		break;
 	    }
@@ -2783,7 +2484,8 @@
 		err->src_addr = conn->peer.sin_addr;
 		err->request = requestLink(request);
 		http->al.http.code = err->http_status;
-		http->entry = clientCreateStoreEntry(http, request->method, null_request_flags);
+		http->entry = clientCreateStoreEntry(http, request->method,
+                  null_request_flags, REPLY_OBJ_INTERNAL);
 		errorAppendEntry(http->entry, err);
 		break;
 	    }
@@ -2798,7 +2500,7 @@
 		    err = errorCon(ERR_TOO_BIG, HTTP_REQUEST_ENTITY_TOO_LARGE);
 		    err->request = requestLink(request);
 		    http->entry = clientCreateStoreEntry(http,
-			METHOD_NONE, null_request_flags);
+			METHOD_NONE, null_request_flags, REPLY_OBJ_INTERNAL);
 		    errorAppendEntry(http->entry, err);
 		    break;
 		}
@@ -2823,7 +2525,8 @@
 		    /* add to the client request queue */
 		    for (H = &conn->chr; *H; H = &(*H)->next);
 		    *H = http;
-		    http->entry = clientCreateStoreEntry(http, METHOD_NONE, null_request_flags);
+		    http->entry = clientCreateStoreEntry(http, METHOD_NONE,
+                      null_request_flags, REPLY_OBJ_INTERNAL);
 		    errorAppendEntry(http->entry, err);
 		    return;
 		}
Index: squid/src/enums.h
diff -u squid/src/enums.h:1.17 squid/src/enums.h:1.2.2.13
--- squid/src/enums.h:1.17	Sat Mar  3 02:44:32 2001
+++ squid/src/enums.h	Sun Mar 18 14:51:21 2001
@@ -487,7 +487,6 @@
     KEY_PRIVATE,
     ENTRY_FWD_HDR_WAIT,
     ENTRY_NEGCACHED,
-    ENTRY_VALIDATED,
     ENTRY_BAD_LENGTH,
     ENTRY_ABORTED
 #if UNUSED_CODE
@@ -634,7 +633,6 @@
     MEM_PS_STATE,
     MEM_REFRESH_T,
     MEM_RELIST,
-    MEM_REQUEST_T,
     MEM_SQUIDCONFIG,
     MEM_SQUIDCONFIG2,
     MEM_STATCOUNTERS,
@@ -726,6 +724,15 @@
 };
 
 /*
+ * reply object types
+ */
+typedef enum {
+    REPLY_OBJ_NONE,
+    REPLY_OBJ_INTERNAL,
+    REPLY_OBJ_NETWORK
+} reply_obj_t;
+
+/*
  * cbdata types. similar to the MEM_* types above, but managed
  * in cbdata.c. A big difference is that these types are dynamically
  * allocated. This list is only a list of predefined types. Other types
@@ -736,7 +743,6 @@
     CBDATA_UNDEF = 0,
     CBDATA_acl_access,
     CBDATA_aclCheck_t,
-    CBDATA_clientHttpRequest,
     CBDATA_ConnStateData,
     CBDATA_DigestFetchState,
     CBDATA_ErrorState,
Index: squid/src/errorpage.c
diff -u squid/src/errorpage.c:1.11 squid/src/errorpage.c:1.2.2.9
--- squid/src/errorpage.c:1.11	Sat Mar  3 02:44:32 2001
+++ squid/src/errorpage.c	Sun Mar 18 14:33:31 2001
@@ -262,7 +262,7 @@
     HttpReply *rep;
     MemObject *mem = entry->mem_obj;
     assert(mem != NULL);
-    assert(mem->inmem_hi == 0);
+    assert(storeMemHiOffset(entry) == 0);
     if (entry->store_status != STORE_PENDING) {
 	/*
 	 * If the entry is not STORE_PENDING, then no clients
@@ -270,7 +270,7 @@
 	 * error message
 	 */
 	assert(EBIT_TEST(entry->flags, ENTRY_ABORTED));
-	assert(mem->nclients == 0);
+	assert(storePendingNClients(entry) == 0);
 	errorStateFree(err);
 	return;
     }
Index: squid/src/forward.c
diff -u squid/src/forward.c:1.10 squid/src/forward.c:1.2.2.7
--- squid/src/forward.c:1.10	Sat Mar  3 02:44:32 2001
+++ squid/src/forward.c	Sun Mar 18 14:33:31 2001
@@ -92,7 +92,7 @@
     fwdLog(fwdState);
 #endif
     if (e->store_status == STORE_PENDING) {
-	if (e->mem_obj->inmem_hi == 0) {
+	if (storeMemHiOffset(e) == 0) {
 	    assert(fwdState->err);
 	    errorAppendEntry(e, fwdState->err);
 	    fwdState->err = NULL;
@@ -130,7 +130,7 @@
 {
     if (fwdState->entry->store_status != STORE_PENDING)
 	return 0;
-    if (fwdState->entry->mem_obj->inmem_hi > 0)
+    if (storeMemHiOffset(fwdState->entry) > 0)
 	return 0;
     if (fwdState->n_tries > 10)
 	return 0;
@@ -249,7 +249,7 @@
     peer *p = fwdStateServerPeer(fwdState);
     debug(17, 2) ("fwdConnectTimeout: FD %d: '%s'\n", fd, storeUrl(entry));
     assert(fd == fwdState->server_fd);
-    if (entry->mem_obj->inmem_hi == 0) {
+    if (storeMemHiOffset(entry) == 0) {
 	err = errorCon(ERR_CONNECT_FAIL, HTTP_GATEWAY_TIMEOUT);
 	err->request = requestLink(fwdState->request);
 	err->xerrno = ETIMEDOUT;
@@ -585,7 +585,7 @@
 #endif
     if (EBIT_TEST(e->flags, ENTRY_FWD_HDR_WAIT))
 	return rc;
-    if (mem->inmem_hi - storeLowestMemReaderOffset(e) < READ_AHEAD_GAP)
+    if (storeMemHiOffset(e) - storeLowestMemReaderOffset(e) < READ_AHEAD_GAP)
 	return rc;
     return 1;
 }
Index: squid/src/ftp.c
diff -u squid/src/ftp.c:1.12 squid/src/ftp.c:1.2.2.8
--- squid/src/ftp.c:1.12	Sat Mar  3 02:44:32 2001
+++ squid/src/ftp.c	Sun Mar 18 14:33:31 2001
@@ -925,11 +925,11 @@
 	    storeAppend(entry, ftpState->data.buf, len);
 	    ftpState->data.offset = 0;
 	}
-	commSetSelect(fd,
-	    COMM_SELECT_READ,
-	    ftpDataRead,
-	    data,
-	    Config.Timeout.read);
+        commSetSelect(fd,
+             COMM_SELECT_READ,
+             ftpDataRead,
+             data,
+             Config.Timeout.read);
     }
 }
 
@@ -1045,7 +1045,6 @@
     const char *url = storeUrl(entry);
     FtpStateData *ftpState;
     HttpReply *reply;
-
     CBDATA_INIT_TYPE(FtpStateData);
     ftpState = cbdataAlloc(FtpStateData);
     debug(9, 3) ("ftpStart: '%s'\n", url);
@@ -2002,6 +2001,11 @@
 static int
 ftpRestartable(FtpStateData * ftpState)
 {
+
+    /* With the advent of the range header in the request_range going away.. */
+    return 0;
+
+#if 0
     if (ftpState->restart_offset > 0)
 	return 1;
     if (!ftpState->request->range)
@@ -2015,6 +2019,7 @@
     if (ftpState->restart_offset <= 0)
 	return 0;
     return 1;
+#endif
 }
 
 static void
@@ -2364,7 +2369,7 @@
 ftpFailed(FtpStateData * ftpState, err_type error)
 {
     StoreEntry *entry = ftpState->entry;
-    if (entry->mem_obj->inmem_hi == 0)
+    if (storeMemHiOffset(entry) == 0)
 	ftpFailedErrorMessage(ftpState, error);
     if (ftpState->data.fd > -1) {
 	comm_close(ftpState->data.fd);
@@ -2480,7 +2485,7 @@
     if (ftpState->flags.http_header_sent)
 	return;
     ftpState->flags.http_header_sent = 1;
-    assert(e->mem_obj->inmem_hi == 0);
+    assert(storeMemHiOffset(e) == 0);
     EBIT_CLR(e->flags, ENTRY_FWD_HDR_WAIT);
     filename = (t = strRChr(urlpath, '/')) ? t + 1 : strBuf(urlpath);
     if (ftpState->flags.isdir) {
@@ -2523,7 +2528,7 @@
 	httpHeaderPutStr(&reply->header, HDR_CONTENT_ENCODING, mime_enc);
     httpReplySwapOut(reply, e);
     storeBufferFlush(e);
-    reply->hdr_sz = e->mem_obj->inmem_hi;
+    reply->hdr_sz = storeMemHiOffset(e);
     storeTimestampsSet(e);
     if (ftpState->flags.authenticated) {
 	/*
Index: squid/src/globals.h
diff -u squid/src/globals.h:1.7 squid/src/globals.h:1.2.2.5
--- squid/src/globals.h:1.7	Fri Jan 12 00:20:33 2001
+++ squid/src/globals.h	Fri Jan 12 00:46:07 2001
@@ -125,6 +125,7 @@
 extern double current_dtime;
 extern int store_hash_buckets;	/* 0 */
 extern hash_table *store_table;	/* NULL */
+extern dlink_list store_list; /* { NULL, NULL } */
 extern dlink_list ClientActiveRequests;
 extern const String StringNull;	/* { 0, 0, NULL } */
 extern const MemBuf MemBufNull;	/* MemBufNULL */
Index: squid/src/gopher.c
diff -u squid/src/gopher.c:1.8 squid/src/gopher.c:1.2.2.6
--- squid/src/gopher.c:1.8	Sat Mar  3 02:44:32 2001
+++ squid/src/gopher.c	Sun Mar 18 14:33:31 2001
@@ -577,7 +577,7 @@
     StoreEntry *entry = gopherState->entry;
     debug(10, 4) ("gopherTimeout: FD %d: '%s'\n", fd, storeUrl(entry));
     if (entry->store_status == STORE_PENDING) {
-	if (entry->mem_obj->inmem_hi == 0) {
+	if (storeMemHiOffset(entry) == 0) {
 	    fwdFail(gopherState->fwdState,
 		errorCon(ERR_READ_TIMEOUT, HTTP_GATEWAY_TIMEOUT));
 	}
@@ -633,7 +633,7 @@
 	debug(50, 1) ("gopherReadReply: error reading: %s\n", xstrerror());
 	if (ignoreErrno(errno)) {
 	    commSetSelect(fd, COMM_SELECT_READ, gopherReadReply, data, 0);
-	} else if (entry->mem_obj->inmem_hi == 0) {
+	} else if (storeMemHiOffset(entry) == 0) {
 	    ErrorState *err;
 	    err = errorCon(ERR_READ_ERROR, HTTP_INTERNAL_SERVER_ERROR);
 	    err->xerrno = errno;
@@ -643,7 +643,7 @@
 	} else {
 	    comm_close(fd);
 	}
-    } else if (len == 0 && entry->mem_obj->inmem_hi == 0) {
+    } else if (len == 0 && storeMemHiOffset(entry) == 0) {
 	ErrorState *err;
 	err = errorCon(ERR_ZERO_SIZE_OBJECT, HTTP_SERVICE_UNAVAILABLE);
 	err->xerrno = errno;
Index: squid/src/http.c
diff -u squid/src/http.c:1.12 squid/src/http.c:1.2.2.8
--- squid/src/http.c:1.12	Sat Mar  3 02:44:32 2001
+++ squid/src/http.c	Sun Mar 18 14:33:31 2001
@@ -93,7 +93,7 @@
     StoreEntry *entry = httpState->entry;
     debug(11, 4) ("httpTimeout: FD %d: '%s'\n", fd, storeUrl(entry));
     if (entry->store_status == STORE_PENDING) {
-	if (entry->mem_obj->inmem_hi == 0) {
+	if (storeMemHiOffset(entry) == 0) {
 	    fwdFail(httpState->fwd,
 		errorCon(ERR_READ_TIMEOUT, HTTP_GATEWAY_TIMEOUT));
 	}
@@ -229,6 +229,13 @@
      */
     if (httpHeaderHas(hdr, HDR_VARY))
 	return 0;
+
+    /* We also don't deal with range requests */
+    if (httpHeaderHas(hdr, HDR_RANGE))
+        return 0;
+    if (httpHeaderHas(hdr, HDR_REQUEST_RANGE))
+        return 0;
+
     /* Pragma: no-cache in _replies_ is not documented in HTTP,
      * but servers like "Active Imaging Webcast/2.0" sure do use it */
     if (httpHeaderHas(hdr, HDR_PRAGMA)) {
@@ -324,7 +331,7 @@
     HttpReply *reply = entry->mem_obj->reply;
     Ctx ctx;
     debug(11, 3) ("httpProcessReplyHeader: key '%s'\n",
-	storeKeyText(entry->hash.key));
+	storeKeyUrl(entry));
     if (httpState->reply_hdr == NULL)
 	httpState->reply_hdr = memAllocate(MEM_8K_BUF);
     assert(httpState->reply_hdr_state == 0);
@@ -405,8 +412,8 @@
 httpPconnTransferDone(HttpStateData * httpState)
 {
     /* return 1 if we got the last of the data on a persistent connection */
-    MemObject *mem = httpState->entry->mem_obj;
-    HttpReply *reply = mem->reply;
+    StoreEntry *entry = httpState->entry;
+    HttpReply *reply = entry->mem_obj->reply;
     int clen;
     debug(11, 3) ("httpPconnTransferDone: FD %d\n", httpState->fd);
     /*
@@ -442,7 +449,7 @@
     if (clen < 0)
 	return 0;
     /* If the body size is known, we must wait until we've gotten all of it.  */
-    if (mem->inmem_hi < reply->content_length + reply->hdr_sz)
+    if (storeMemHiOffset(entry) < reply->content_length + reply->hdr_sz)
 	return 0;
     /* We got it all */
     return 1;
@@ -512,7 +519,7 @@
 	    fd, xstrerror());
 	if (ignoreErrno(errno)) {
 	    commSetSelect(fd, COMM_SELECT_READ, httpReadReply, httpState, 0);
-	} else if (entry->mem_obj->inmem_hi == 0) {
+	} else if (storeMemHiOffset(entry) == 0) {
 	    ErrorState *err;
 	    err = errorCon(ERR_READ_ERROR, HTTP_INTERNAL_SERVER_ERROR);
 	    err->xerrno = errno;
@@ -521,7 +528,7 @@
 	} else {
 	    comm_close(fd);
 	}
-    } else if (len == 0 && entry->mem_obj->inmem_hi == 0) {
+    } else if (len == 0 && storeMemHiOffset(entry) == 0) {
 	ErrorState *err;
 	err = errorCon(ERR_ZERO_SIZE_OBJECT, HTTP_SERVICE_UNAVAILABLE);
 	err->xerrno = errno;
@@ -647,7 +654,6 @@
     LOCAL_ARRAY(char, bbuf, BBUF_SZ);
     String strConnection = StringNull;
     const HttpHeader *hdr_in = &orig_request->header;
-    int we_do_ranges;
     const HttpHeaderEntry *e;
     String strVia;
     String strFwd;
@@ -657,26 +663,8 @@
     if (request->lastmod > -1 && request->method == METHOD_GET)
 	httpHeaderPutTime(hdr_out, HDR_IF_MODIFIED_SINCE, request->lastmod);
 
-    /* decide if we want to do Ranges ourselves 
-     * (and fetch the whole object now)
-     * We want to handle Ranges ourselves iff
-     *    - we can actually parse client Range specs
-     *    - the specs are expected to be simple enough (e.g. no out-of-order ranges)
-     *    - reply will be cachable
-     * (If the reply will be uncachable we have to throw it away after 
-     *  serving this request, so it is better to forward ranges to 
-     *  the server and fetch only the requested content) 
-     */
-    if (NULL == orig_request->range)
-	we_do_ranges = 0;
-    else if (!orig_request->flags.cachable)
-	we_do_ranges = 0;
-    else if (httpHdrRangeOffsetLimit(orig_request->range))
-	we_do_ranges = 0;
-    else
-	we_do_ranges = 1;
-    debug(11, 8) ("httpBuildRequestHeader: range specs: %p, cachable: %d; we_do_ranges: %d\n",
-	orig_request->range, orig_request->flags.cachable, we_do_ranges);
+    /* We are not doing ranges at all now - we're just passing them through */
+    debug(11, 8) ("httpBuildRequestHeader: cachable: %d\n", orig_request->flags.cachable);
 
     strConnection = httpHeaderGetList(hdr_in, HDR_CONNECTION);
     while ((e = httpHeaderGetEntry(hdr_in, &pos))) {
@@ -737,12 +725,6 @@
 		    httpHeaderPutInt(hdr_out, HDR_MAX_FORWARDS, hops - 1);
 	    }
 	    break;
-	case HDR_RANGE:
-	case HDR_IF_RANGE:
-	case HDR_REQUEST_RANGE:
-	    if (!we_do_ranges)
-		httpHeaderAddEntry(hdr_out, httpHeaderEntryClone(e));
-	    break;
 	case HDR_PROXY_CONNECTION:
 	case HDR_CONNECTION:
 	case HDR_VIA:
Index: squid/src/main.c
diff -u squid/src/main.c:1.19 squid/src/main.c:1.2.2.10
--- squid/src/main.c:1.19	Tue Jan 30 16:27:46 2001
+++ squid/src/main.c	Tue Feb  6 02:08:04 2001
@@ -479,6 +479,7 @@
 #else
     idnsInit();
 #endif
+    requestInit();
     redirectInit();
     authenticateInit(&Config.authConfig);
     useragentOpenLog();
@@ -501,6 +502,9 @@
 #if USE_UNLINKD
 	unlinkdInit();
 #endif
+        reply_internal_init();
+        reply_network_init();
+
 	urlInitialize();
 	cachemgrInit();
 	statInit();
Index: squid/src/mem.c
diff -u squid/src/mem.c:1.9 squid/src/mem.c:1.2.2.4
--- squid/src/mem.c:1.9	Sat Feb 17 12:56:22 2001
+++ squid/src/mem.c	Tue Feb 20 07:39:42 2001
@@ -275,8 +275,6 @@
     memDataInit(MEM_PS_STATE, "ps_state", sizeof(ps_state), 0);
     memDataInit(MEM_REFRESH_T, "refresh_t", sizeof(refresh_t), 0);
     memDataInit(MEM_RELIST, "relist", sizeof(relist), 0);
-    memDataInit(MEM_REQUEST_T, "request_t", sizeof(request_t),
-	Squid_MaxFD >> 3);
     memDataInit(MEM_SQUIDCONFIG, "SquidConfig", sizeof(SquidConfig), 0);
     memDataInit(MEM_SQUIDCONFIG2, "SquidConfig2", sizeof(SquidConfig2), 0);
     memDataInit(MEM_STATCOUNTERS, "StatCounters", sizeof(StatCounters), 0);
Index: squid/src/mime.c
diff -u squid/src/mime.c:1.8 squid/src/mime.c:1.2.2.9
--- squid/src/mime.c:1.8	Fri Jan 12 00:20:33 2001
+++ squid/src/mime.c	Wed Feb  7 05:54:38 2001
@@ -364,12 +364,18 @@
 	debug(25, 5) ("mimeInit: added '%s'\n", buf);
     }
     fclose(fp);
+
     /*
      * Create Icon StoreEntry's
      */
+
+    /* Remember, we're not doing icons in this fashion.. -- adrian */
+#if 0
     for (m = MimeTable; m != NULL; m = m->next)
 	mimeLoadIconFile(m->icon);
     debug(25, 1) ("Loaded Icons.\n");
+#endif
+    debug(25, 1) ("Not loading icons.\n");
 }
 
 void
@@ -391,62 +397,5 @@
 static void
 mimeLoadIconFile(const char *icon)
 {
-    int fd;
-    int n;
-    request_flags flags;
-    struct stat sb;
-    StoreEntry *e;
-    LOCAL_ARRAY(char, path, MAXPATHLEN);
-    LOCAL_ARRAY(char, url, MAX_URL);
-    char *buf;
-    const char *type = mimeGetContentType(icon);
-    HttpReply *reply;
-    http_version_t version;
-    if (type == NULL)
-	fatal("Unknown icon format while reading mime.conf\n");
-    buf = internalLocalUri("/squid-internal-static/icons/", icon);
-    xstrncpy(url, buf, MAX_URL);
-    if (storeGetPublic(url, METHOD_GET))
-	return;
-    snprintf(path, MAXPATHLEN, "%s/%s", Config.icons.directory, icon);
-    fd = file_open(path, O_RDONLY | O_BINARY);
-    if (fd < 0) {
-	debug(25, 0) ("mimeLoadIconFile: %s: %s\n", path, xstrerror());
-	return;
-    }
-    if (fstat(fd, &sb) < 0) {
-	debug(50, 0) ("mimeLoadIconFile: FD %d: fstat: %s\n", fd, xstrerror());
-	return;
-    }
-    flags = null_request_flags;
-    flags.cachable = 1;
-    e = storeCreateEntry(url,
-	url,
-	flags,
-	METHOD_GET);
-    assert(e != NULL);
-    storeSetPublicKey(e);
-    storeBuffer(e);
-    e->mem_obj->request = requestLink(urlParse(METHOD_GET, url));
-    httpReplyReset(reply = e->mem_obj->reply);
-    httpBuildVersion(&version, 1, 0);
-    httpReplySetHeaders(reply, version, HTTP_OK, NULL,
-	type, (int) sb.st_size, sb.st_mtime, -1);
-    reply->cache_control = httpHdrCcCreate();
-    httpHdrCcSetMaxAge(reply->cache_control, 86400);
-    httpHeaderPutCc(&reply->header, reply->cache_control);
-    httpReplySwapOut(reply, e);
-    reply->hdr_sz = e->mem_obj->inmem_hi;	/* yuk */
-    /* read the file into the buffer and append it to store */
-    buf = memAllocate(MEM_4K_BUF);
-    while ((n = read(fd, buf, 4096)) > 0)
-	storeAppend(e, buf, n);
-    file_close(fd);
-    EBIT_SET(e->flags, ENTRY_SPECIAL);
-    storeBufferFlush(e);
-    storeComplete(e);
-    storeTimestampsSet(e);
-    debug(25, 3) ("Loaded icon %s\n", url);
-    storeUnlockObject(e);
-    memFree(buf, MEM_4K_BUF);
+	fatal("I shouldn't get here yet!\n");
 }
Index: squid/src/neighbors.c
diff -u squid/src/neighbors.c:1.9 squid/src/neighbors.c:1.2.2.7
--- squid/src/neighbors.c:1.9	Sat Mar  3 02:44:32 2001
+++ squid/src/neighbors.c	Sun Mar 18 14:51:21 2001
@@ -1122,7 +1122,8 @@
     assert(p->type == PEER_MULTICAST);
     p->mcast.flags.count_event_pending = 0;
     snprintf(url, MAX_URL, "http://%s/", inet_ntoa(p->in_addr.sin_addr));
-    fake = storeCreateEntry(url, url, null_request_flags, METHOD_GET);
+    fake = storeCreateEntry(url, url, null_request_flags, METHOD_GET,
+      REPLY_OBJ_INTERNAL);
     psstate = cbdataAlloc(ps_state);
     psstate->request = requestLink(urlParse(METHOD_GET, url));
     psstate->entry = fake;
Index: squid/src/net_db.c
diff -u squid/src/net_db.c:1.10 squid/src/net_db.c:1.2.2.8
--- squid/src/net_db.c:1.10	Sat Mar  3 02:44:32 2001
+++ squid/src/net_db.c	Sun Mar 18 14:33:32 2001
@@ -627,8 +627,8 @@
 	debug(38, 3) ("netdbExchangeHandleReply: STORE_PENDING\n");
 	storeClientCopy(ex->sc, ex->e, ex->seen, ex->used, ex->buf_sz,
 	    ex->buf, netdbExchangeHandleReply, ex);
-    } else if (ex->seen < ex->e->mem_obj->inmem_hi) {
-	debug(38, 3) ("netdbExchangeHandleReply: ex->e->mem_obj->inmem_hi\n");
+    } else if (ex->seen < storeMemHiOffset(ex->e)) {
+	debug(38, 3) ("netdbExchangeHandleReply: storeMemHiOffset(ex->e)\n");
 	storeClientCopy(ex->sc, ex->e, ex->seen, ex->used, ex->buf_sz,
 	    ex->buf, netdbExchangeHandleReply, ex);
     } else {
@@ -644,7 +644,7 @@
     debug(38, 3) ("netdbExchangeDone: %s\n", storeUrl(ex->e));
     memFree(ex->buf, MEM_4K_BUF);
     requestUnlink(ex->r);
-    storeUnregister(ex->sc, ex->e, ex);
+    storeClientUnregister(ex->sc, ex->e, ex);
     storeUnlockObject(ex->e);
     cbdataUnlock(ex->p);
     cbdataFree(ex);
@@ -1005,11 +1005,12 @@
     requestLink(ex->r);
     assert(NULL != ex->r);
     httpBuildVersion(&ex->r->http_ver, 1, 0);
-    ex->e = storeCreateEntry(uri, uri, null_request_flags, METHOD_GET);
+    ex->e = storeCreateEntry(uri, uri, null_request_flags, METHOD_GET,
+      REPLY_OBJ_INTERNAL);
     ex->buf_sz = 4096;
     ex->buf = memAllocate(MEM_4K_BUF);
     assert(NULL != ex->e);
-    ex->sc = storeClientListAdd(ex->e, ex);
+    ex->sc = storeClientRegister(ex->e, ex);
     storeClientCopy(ex->sc, ex->e, ex->seen, ex->used, ex->buf_sz,
 	ex->buf, netdbExchangeHandleReply, ex);
     ex->r->flags.loopdetect = 1;	/* cheat! -- force direct */
